#version 330 core
layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

in vec3 vColor[];
in float vMass[];

out vec2 coords;
out vec3 fColor;

const float aspect = 16.0 / 9;

void main() {
	fColor = vColor[0];
	
	vec4 pos = gl_in[0].gl_Position;
	float scale = pow(vMass[0], 1.0 / 3);
	float size = scale * 0.01;
	
	coords = vec2(-1, 1);
	gl_Position = vec4(pos.x - size / aspect, pos.y + size, pos.z, pos.w);
	EmitVertex();
	
	coords = vec2(-1, -1);
	gl_Position = vec4(pos.x - size / aspect, pos.y - size, pos.z, pos.w);
	EmitVertex();
	
	coords = vec2(1, 1);
	gl_Position = vec4(pos.x + size / aspect, pos.y + size, pos.z, pos.w);
	EmitVertex();
	
	coords = vec2(1, -1);
	gl_Position = vec4(pos.x + size / aspect, pos.y - size, pos.z, pos.w);
	EmitVertex();
	
	EndPrimitive();
}